package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.UserComment;
import com.izouma.awesomeadmin.service.UserCommentService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/userComment")
public class UserCommentController {

    @Autowired
    private UserCommentService userCommentService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(UserComment record) {
        List<UserComment> pp = userCommentService.getUserCommentList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getUserComment", method = RequestMethod.GET)
    @ResponseBody
    public Result getUserComment(@RequestParam(required = false, value = "id") String id) {
        UserComment data = userCommentService.getUserCommentById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(UserComment record) {
        UserComment data = userCommentService.getUserComment(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, UserComment record) {
        Map<String, Object> result = new HashMap<>();

        List<UserComment> pp =userCommentService.getUserCommentByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(UserComment record) {
        boolean num = userCommentService.createUserComment(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateUserComment(UserComment record) {
        boolean num = userCommentService.updateUserComment(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteUserComment(UserComment record) {

        boolean num = userCommentService.deleteUserComment(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, UserComment record) throws Exception {

    List<UserComment> userComments = userCommentService.getUserCommentList(record);


        String sheetName = "user_comment";
        String titleName = "用户评论数据表";
        String fileName = "用户评论表";
        int columnNumber = 18;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "用户" ,   "地标" ,   "起点" ,   "终点" ,   "评论" ,   "类别" ,   "星级" ,   "备注" ,   "备注1" ,   "备注2" ,   "备注3" ,   "备注4"  };
        String[][] dataList = new String[userComments.size()][18];

        for (int i = 0; i < userComments.size(); i++) {

                        dataList[i][0] = String.valueOf(userComments.get(i).getId());
                        dataList[i][1] = String.valueOf(userComments.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(userComments.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(userComments.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(userComments.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(userComments.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(userComments.get(i).getUserId());
                        dataList[i][7] = String.valueOf(userComments.get(i).getLandmarkId());
                        dataList[i][8] = String.valueOf(userComments.get(i).getStartPlace());
                        dataList[i][9] = String.valueOf(userComments.get(i).getEndPlace());
                        dataList[i][10] = String.valueOf(userComments.get(i).getCommentText());
                        dataList[i][11] = String.valueOf(userComments.get(i).getTypeFlag());
                        dataList[i][12] = String.valueOf(userComments.get(i).getStarLevel());
                        dataList[i][13] = String.valueOf(userComments.get(i).getRemark());
                        dataList[i][14] = String.valueOf(userComments.get(i).getRemark1());
                        dataList[i][15] = String.valueOf(userComments.get(i).getRemark2());
                        dataList[i][16] = String.valueOf(userComments.get(i).getRemark3());
                        dataList[i][17] = String.valueOf(userComments.get(i).getRemark4());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

